Attribute VB_Name = "OCC_dll"
Private Declare Sub OCC_Set Lib "OCCdll.dll" (s As Long, t As Long, g As Long)
Private Declare Sub OCC_X Lib "OCCdll.dll" (n As Long, x As Double)
Private Declare Sub OCC_W Lib "OCCdll.dll" (x As Double, n As Long, w As Double)
Private Declare Sub OCC_A Lib "OCCdll.dll" (x As Double, n As Long, A As Double)
Private Declare Sub OCC_B Lib "OCCdll.dll" (x As Double, n As Long, B As Double)
Private Declare Sub OCC_C Lib "OCCdll.dll" (x As Double, n As Long, C As Double)
Private Declare Sub OCC_D Lib "OCCdll.dll" (x As Double, n As Long, D As Double)
Private Declare Sub OCC_L Lib "OCCdll.dll" (x As Double, xx As Double, n As Long, L As Double)
Private Declare Sub OCC_Anon Lib "OCCdll.dll" (x As Double, n As Long, a As Double)
Sub OCC_Settings(sym, typ, geom)
' Settings for the other calculations
' It should be possible to set up as a Sub
' See button code for one method to call this
' Do not know how to call and get values of named range
' Can only get the values from specific cells, e.g. E1, E2 & E3
    Dim s As Long
    Dim t As Long
    Dim g As Long
    s = sym
    t = typ
    g = geom
    Call OCC_Set(s, t, g)
End Sub
Function OCC_Setup(sym, typ, geom)
' Settings for the other calculations
' It should be possible to set up as a Sub
    Dim s As Long
    Dim t As Long
    Dim g As Long
    s = sym
    t = typ
    g = geom
    Call OCC_Set(s, t, g)
    OCC_Setup = s * 1000 + t * 100 + g
End Function
Function OCC_Points(Ntotal)
' Return the collocation points, Gauss or Lobatto
    Dim n As Long
    Dim x() As Double
    n = Ntotal
    ReDim x(1 To n)
    Call OCC_X(n, x(1))
    OCC_Points = Application.Transpose(x)
End Function
Function OCC_Weights(xc)
' Return the quadrature weights
    Dim n As Long
    Dim i As Long
    Dim x() As Double
    Dim w() As Double
    n = xc.Count
    ReDim x(1 To n)
    ReDim w(1 To n)
    For i = 1 To n
        x(i) = xc(i)
    Next i
    Call OCC_W(x(1), n, w(1))
    OCC_Weights = Application.Transpose(w)
End Function
Function OCC_Acoef(xc)
' Return the first derivative matrix operator
    Dim n As Long
    Dim i As Long
    Dim x() As Double
    Dim A() As Double
    n = xc.Count
    ReDim x(1 To n)
    ReDim A(1 To n, 1 To n)
    For i = 1 To n
        x(i) = xc(i)
    Next i
    Call OCC_A(x(1), n, A(1, 1))
    OCC_Acoef = A
End Function
Function OCC_Bcoef(xc)
' Return the Laplacian matrix operator
    Dim n As Long
    Dim j As Long
    Dim x() As Double
    Dim B() As Double
    n = xc.Count
    ReDim x(1 To n)
    ReDim B(1 To n, 1 To n)
    For j = 1 To n
        x(j) = xc(j)
    Next j
    Call OCC_B(x(1), n, B(1, 1))
    OCC_Bcoef = B
End Function
Function OCC_Ccoef(xc)
' Return the WAtA matrix
    Dim n As Long
    Dim j As Long
    Dim x() As Double
    Dim C() As Double
    n = xc.Count
    ReDim x(1 To n)
    ReDim C(1 To n, 1 To n)
    For j = 1 To n
        x(j) = xc(j)
    Next j
    Call OCC_C(x(1), n, C(1, 1))
    OCC_Ccoef = C
End Function
Function OCC_Dcoef(xc)
' Return the Mass matrix, Galerkin or Moments
    Dim n As Long
    Dim i As Long
    Dim x() As Double
    Dim A() As Double
    n = xc.Count
    ReDim x(1 To n)
    ReDim A(1 To n, 1 To n)
    For i = 1 To n
        x(i) = xc(i)
    Next i
    Call OCC_D(x(1), n, A(1, 1))
    OCC_Dcoef = A
End Function
Function OCC_Linterp(xv, xc)
' Return values of Lagrange interpolating polynomial evaluated at xv
    Dim n As Long
    Dim j As Long
    Dim xx As Double
    Dim x() As Double
    Dim L() As Double
    n = xc.Count
    ReDim x(1 To n)
    ReDim L(1 To n)
    xx = xv
    For j = 1 To n
        x(j) = xc(j)
    Next j
    Call OCC_L(xx, x(1), n, L(1))
    OCC_Linterp = L
End Function
Function OCC_AcoefN(xc)
' Return the first derivative matrix operator
    Dim n As Long
    Dim i As Long
    Dim x() As Double
    Dim A() As Double
    n = xc.Count
    ReDim x(1 To n)
    ReDim A(1 To n, 1 To n)
    For i = 1 To n
        x(i) = xc(i)
    Next i
    Call OCC_Anon(x(1), n, A(1, 1))
    OCC_AcoefN = A
End Function

